checkRequire("Lua_ItemShowModelPanel");
Lua_NewZeroGiftPanel  = class("Lua_NewZeroGiftPanel", Lua_DisplayObject);
function Lua_NewZeroGiftPanel:ctor(p)
	self:superCall("ctor", p, "NewZeroGiftPlane_skin");
end

function Lua_NewZeroGiftPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content,1, Vector4(0, 0, 222, 138));
	self.rewardList:setLocation(45, -79, 0);
	self.rewardList:setListCell(Lua_NewZeroGiftRewardItem, 69, 74, 3);

	self.getBtn:addClickFuntion(self, self.onGetBtnClick);
end

function Lua_NewZeroGiftPanel:setData(msg)
	self._data = msg;
end

function Lua_NewZeroGiftPanel:updateZeroPanelInfo()
	self.desIcon:SetDimensions(0, 0);
	self.desIcon:setUrl("/images/operationalActivities/" .. self._data.reward_content .. ".png");
	self:onCreateModel();

	local arr = DataCenter.newZeroGiftData:getNewZeroGiftDataArr(self._data.gift_index);
	self.rewardList:setLuaArrayData(arr, false);
	self.rewardList:moveToIndex(1, true);

	if self._data.restore_money.copper ~= 0 or self._data.restore_money.bind_copper ~= 0 then
		self.moneyIcon:setAltas("icon_atlas_3", "money_209000001");
		self.moneyCountLab.text = self._data.restore_money.copper;
	elseif self._data.restore_money.bind_gold ~= 0 then
		self.moneyIcon:setAltas("icon_atlas_3", "money_209000002");
		self.moneyCountLab.text = self._data.restore_money.bind_gold;
	elseif self._data.restore_money.gold ~= 0 then
		self.moneyIcon:setAltas("icon_atlas_3", "money_209000003");
		self.moneyCountLab.text = self._data.restore_money.gold;
	elseif self._data.restore_money.diamond ~= 0 then
		self.moneyIcon:setAltas("icon_atlas_3", "money_209000020");
		self.moneyCountLab.text = self._data.restore_money.diamond;
	end

	-- draw_flag 领取标识：0 不可领取，1 可领取，2 已领取
	-- cond_type 条件类型：1 等级，2 主线任务，3 消耗铜钱，4 消耗礼金，5 消耗元宝
	if self._data.draw_flag == 0 then
		if self._data.cond_type == 1 then
			self:setBtnState();
			self.desLab.text = LanUtil.formateStr(LanUtil.getValue(141901), tostring(self._data.need_amount));
		elseif self._data.cond_type == 2 then
			self:setBtnState();
			self.desLab.text = LanUtil.formateStr(LanUtil.getValue(141902), tostring(self._data.need_amount));
		elseif self._data.cond_type == 3 or self._data.cond_type == 4 or self._data.cond_type == 5 then
			self:setBtnState(141903, true);
		end
	elseif self._data.draw_flag == 1 then
		self:setBtnState(140714, true);
	elseif self._data.draw_flag == 2 then
		if self._data.cond_type == 1 or self._data.cond_type == 2 then
			self:setBtnState(140715, false);
		elseif self._data.cond_type == 3 or self._data.cond_type == 4 or self._data.cond_type == 5 then
			self:setBtnState(141907, false);
		end
	end
	self.redDot:setEnable(self._data.draw_flag == 1);
end

function Lua_NewZeroGiftPanel:onCreateModel()
	if self.fazhenEffect == nil then
		self.fazhenEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_zreoyuan_fazhen", "gui_zreoyuan_fazhen", -280, -210);
		self.fazhenEffect:SetRenderQueue(self.desIcon, 5, 2, false);
	end
	self:onDisposeModel();

	local str = string.split(self._data.valuable_model, ",");
	local pos = Vector3(tonumber(str[2]), tonumber(str[3]), tonumber(str[4]));
	local rot = Vector3(tonumber(str[5]), tonumber(str[6]), tonumber(str[7]));
	local sca = Vector3(tonumber(str[8]), tonumber(str[9]), tonumber(str[10]));
	local bgPath = "/images/operationalActivities/ui_0yuan_bg_03.png";
	if tonumber(str[1]) == nil then -- 非道具ID，即礼包模型
		if self.modelBg == nil then
			self.modelBg = UICreate.createImage(self.content, bgPath, -276, -43, 0, 0);
			self.modelBg:setDepth(3);
		end

		if self.showModel == nil then
			self.showModel = UICreate.createUIEffect(self.content, "/effects/scsEffects/" .. str[1], str[1], 0, 0);
			self.showModel:SetRenderQueue(self.modelBg, 5, 2, false);
			self.showModel:setScale(sca.x, sca.y, sca.z)
			self.showModel:setRot(rot.x, rot.y, rot.z);
			self.showModel:setLocation(pos.x, pos.y, pos.z);
		end
	else
		local tvo = Lua_ToolVo.createToolVo(tonumber(str[1]));
		if self.modelPanel == nil then
			self.modelPanel = Lua_ItemShowModelPanel.new(self.content, 334, 430, -276, 172, pos, rot, sca, true, true);
			self.modelPanel.bg:setUrl(bgPath);
			self.modelPanel:setShowData(tvo);
		end
	end
end

function Lua_NewZeroGiftPanel:onDisposeModel()
	if self.modelBg ~= nil then
		self.modelBg:dispose();
		self.modelBg = nil;
	end
	if self.showModel ~= nil then
		self.showModel:dispose();
		self.showModel = nil;
	end
	if self.modelPanel ~= nil then
		self.modelPanel:dispose();
		self.modelPanel = nil;
	end
end

function Lua_NewZeroGiftPanel:setBtnState(val, bool)
	if val == nil and bool == nil then
		self.desLab:setEnable(true);
		self.getBtn:setEnable(false);
	else
		self.desLab:setEnable(false);
		self.getBtn.label = LanUtil.getValue(val);
		self.getBtn:setEnable(true);
		self.getBtn:setBtnEnable(bool);
	end
end

function Lua_NewZeroGiftPanel:onGetBtnClick()
	if self._data.draw_flag == 0 then
		if self._data.cond_type == 3 then
			if DataCenter.moneyData:getMoney(Lua_MoneyData.COPPER) < self._data.need_amount then
				DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.COPPER, self._data.need_amount, true, false);
			else
				self.enough = true;
				self:onSureFun();
			end
		elseif self._data.cond_type == 4 then
			self:onBuyFun(Lua_MoneyData.BIND_GOLD, 141905);
		elseif self._data.cond_type == 5 then
			self:onBuyFun(Lua_MoneyData.GOLD, 141904);
		end	
	elseif self._data.draw_flag == 1 then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityRewards(Lua_OperationalActivitiesData.ACT_NEW_ZERO_GIFT, self._data.gift_index);
	end
end

function Lua_NewZeroGiftPanel:onBuyFun(money_type, lang)
	local str;
	if DataCenter.moneyData:getMoney(money_type) < self._data.need_amount then
		str = "[" .. Lua_ColorDefine.RED_STR .. "]" .. self._data.need_amount .. "[-]";
		self.enough = false;
	else
		str = "[" .. Lua_ColorDefine.GREEN_STR .. "]" .. self._data.need_amount .. "[-]";
		self.enough = true;
	end

	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, type = 1, subFun = self.onSureFun,
		des = LanUtil.formateStr(LanUtil.getValue(lang), str, tostring(self._data.gift_title))});
end

function Lua_NewZeroGiftPanel:onSureFun()
	if self.enough == true then
		Lua_ProxyManager.getProxy("Lua_NewZeroGiftProxy"):sBuyGift(self._data.gift_index, Lua_OperationalActivitiesData.ACT_NEW_ZERO_GIFT);
	else
		DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self._data.need_amount, true, true);
	end
end

function Lua_NewZeroGiftPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.fazhenEffect ~= nil then
		self.fazhenEffect:dispose();
		self.fazhenEffect = nil;
	end
	self:onDisposeModel();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_NewZeroGiftRewardItem = class("Lua_NewZeroGiftRewardItem", Lua_ListCell);
function Lua_NewZeroGiftRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_NewZeroGiftRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setScale(0.7, 0.7);
	self.itemImg:setCanClick(false);
end

function Lua_NewZeroGiftRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemImg.data = data.tvo;
	self.itemImg:showMaskSp(false);
	self.itemImg:showNotYetImg(false);

	if data.show_effect == 1 then
		if data.tvo.subType == Lua_PackTypeDefine.STAMP_ITEM then
			self.itemImg:showStampEff(true);
		else
			self.itemImg:showRoundEff(true);
		end
	end
end

function Lua_NewZeroGiftRewardItem:onPlayerSoundClick()
	if self._data ~= nil then
		Lua_PackUtil.showItemInfo(self.itemImg.data);
	end
end

function Lua_NewZeroGiftRewardItem:checkOutBound(showRect)
	if self._data ~= nil and self._data.show_effect == 1 then
		local rect = Lua_Rectangle.new(self.itemX, self.itemY - 26, 26, 58);
		if self.itemImg.data.subType == Lua_PackTypeDefine.STAMP_ITEM then
			self.itemImg:showStampEff(showRect:containeRect(rect));
		else
			self.itemImg:showRoundEff(showRect:containeRect(rect));
		end
	end
end

function Lua_NewZeroGiftRewardItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end