-- 新0元礼包
checkRequire("Lua_NewZeroGiftPanel");
checkRequire("Lua_NewZeroGiftBtnItem");
Lua_NewZeroGiftWindow  = class("Lua_NewZeroGiftWindow", Lua_Window);
function Lua_NewZeroGiftWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_NewZeroGiftWindow";
	self.skinName = "NewZeroGiftWindow_skin";
end

function Lua_NewZeroGiftWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnArr = Array();
	self.curPanel = Lua_NewZeroGiftPanel.new(self.content);

	DataCenter.redDotData:updateRedDotVoState(22059, false);

	self:addLuaEvent("UPDATE_ACT_NEW_ZERO_GIFT", self, self.updateNewZeroGiftInfo);
	self:addLuaEvent("NewZeroGiftBtnItemClick", self, self.onBtnClick);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.ACT_NEW_ZERO_GIFT);
end

function Lua_NewZeroGiftWindow:updateNewZeroGiftInfo()
	self:startTimer();
	self:updateResidueTime();

	local arr = DataCenter.newZeroGiftData.newZeroGiftDataArr;
	for i = self.btnArr:getSize(), self.btnArr:getSize() - arr:getSize() - 1 do
		if i > 0 then
			self.btnArr[i]:setEnable(false);
		else
			break;
		end
	end

	local curSelectIdx = self.selectIdx == nil and 1 or self.selectIdx;
	if arr:getSize() > 0 then
		local btn;
		for i = 1, arr:getSize() do
			btn = self.btnArr[i];
			if btn == nil then
				btn = Lua_NewZeroGiftBtnItem.new(self.content);
				btn.content.name = "Lua_NewZeroGiftBtnItem_"..i;
				btn:setDepth(2);
				btn:setLocation(-20 + (i - 1) * 171, 244, 0);
				self.btnArr:add(btn);
			end
			btn:setEnable(true);
			btn:setData(arr[i]);-- 更新数据
		end
		self:onBtnClick(arr[curSelectIdx]);
	end
end

function Lua_NewZeroGiftWindow:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_NewZeroGiftWindow", 1, self, self.updateResidueTime);
	end
end

function Lua_NewZeroGiftWindow:updateResidueTime()
	local leftTime = tonumber(DataCenter.newZeroGiftData.endTick) - DataCenter.roleData.serverTime;
	self.leftTimeLab.text = LanUtil.formateStr(LanUtil.getValue(141900), TimeTransform.getInstance():transSeconds1(leftTime, true));
	if leftTime <= 0 then
		self.leftTimeLab.text = LanUtil.getValue(141906);
		self:endTimer();
	end
end

function Lua_NewZeroGiftWindow:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateResidueTime);
	end
end

function Lua_NewZeroGiftWindow:onBtnClick(info)
	self.selectIdx = info.index;
	for i = 1, self.btnArr:getSize() do
		self.btnArr[i]:onSelectionChange(i == info.index);
		if i == info.index then
			self.btnArr[i]:setLocation(-20 + (i - 1) * 171, 247, 0);
		else
			self.btnArr[i]:setLocation(-20 + (i - 1) * 171, 244, 0);
		end
	end

	self.curPanel:setData(info);
	self.curPanel:updateZeroPanelInfo();
end

function Lua_NewZeroGiftWindow:dispose()
	if self.btnArr ~= nil then
		self.btnArr:dispose();
		self.btnArr:clear();
		self.btnArr = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end